<?php
/*
Plugin Name: Comment Numbering
Plugin URI: http://dage.jp/
Description: 記事ごとにコメントに番号を振っていくプラグインです。WP 3.0 で動作確認済。
Version: 0.1.0
Author: dage
Author URI: http://dage.jp/
*/

/*  Copyright 2010 dage

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/



define('COMMENT_NUMBERING_META_KEY_NAME', 'ctnb_comment_detail_number');


/**
 * action : comment_post
 */
function ctnb_comment_post( $comment_id ){
	global $wp_version;
	global $wpdb;

	// バージョン 3.0以上
	if( 3 > $wp_version ){
		return;
	}



	// post_id 取得
	$post_id = $wpdb->get_var("SELECT comment_post_ID FROM wp_comments WHERE comment_ID = ".$comment_id." LIMIT 1;");


	// コメント詳細番号、最大値取得
	//$max_detail_id = $wpdb->get_var("SELECT MAX(meta_value) AS detail_number FROM wp_commentmeta WHERE meta_key = '".COMMENT_NUMBERING_META_KEY_NAME."'");
	$max_detail_id = $wpdb->get_var("SELECT MAX(meta_value) FROM wp_commentmeta LEFT JOIN wp_comments ON wp_commentmeta.comment_id = wp_comments.comment_ID WHERE comment_post_ID = ".$post_id);

	if ( !is_numeric($max_detail_id) ){
		$max_detail_id=0;
	}

	$max_detail_id++;

	add_comment_meta( $comment_id, COMMENT_NUMBERING_META_KEY_NAME, $max_detail_id );
}



function ctnb_comments_array( $comments ){
	global $wpdb;
	// コメント詳細番号、読み出し
	foreach( $comments as &$comment ){
		$comment->ctnb_comment_number = $wpdb->get_var("SELECT meta_value AS comment_number FROM wp_commentmeta WHERE comment_id = '".$comment->comment_ID."' AND meta_key = '".COMMENT_NUMBERING_META_KEY_NAME."'");
	}

	return $comments;
}


add_action('comment_post', 'ctnb_comment_post');

add_filter('comments_array', 'ctnb_comments_array');

?>
